#! /usr/bin/env python
# -*- coding: utf-8 -*-

#	Copyright 2017, Marten de Vries
#
#	This file is part of OpenTeacher.
#
#	OpenTeacher is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	OpenTeacher is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with OpenTeacher.  If not, see <http://www.gnu.org/licenses/>.

import os

class SimpleTranslatorModule:
	"""A wrapper around the translator module (with fallback to plain functions)

	It makes translating a module a lot easier, as long as said modules follows
	conventions. Which, 99% of all OT modules do.

	It allows you to simply specify a function to use for (re)translation, and
	the directory of the current module to look into for translations (which is
	trivially done by passing self._mm.resourcePath(), then handles everything.)

	"""
	def __init__(self, moduleManager):
		self._mm = moduleManager

		self.type = "simpleTranslator"
		self.uses = (
			self._mm.mods(type='translator'),
		)

	def setupTranslation(self, modPath, retranslate):
		def wrapper():
			if self._translator:
				translations = os.path.join(modPath, 'translations')
				funcs = self._translator.gettextFunctions(translations)
			else:
				funcs = (lambda t: t, lambda a, b, n: a if n == 1 else b)
			retranslate(*funcs)

		if self._translator:
			self._translator.languageChanged.handle(wrapper)
		wrapper()

	def enable(self):
		modules = next(iter(self._mm.mods(type='modules')))
		try:
			self._translator = modules.default('active', type='translator')
		except IndexError:
			self._translator = None

		self.active = True

	def disable(self):
		self.active = False

		del self._translator

def init(moduleManager):
	return SimpleTranslatorModule(moduleManager)
